import type { Bank, OAuthTokenResponse, Transaction } from "@/sparebank1.ts"

const tokenResponse: OAuthTokenResponse = {
  access_token: "my_access_token",
  token_type: "Bearer",
  expires_in: 3600,
  refresh_token: "my_refresh_token",
  refresh_token_expires_in: 3600,
  refresh_token_absolute_expires_in: 3600,
}

export class BankStub implements Bank {
  async accessToken(): Promise<OAuthTokenResponse> {
    return tokenResponse
  }

  async refreshToken(_unused: string): Promise<OAuthTokenResponse> {
    return tokenResponse
  }

  async transactionsPastDay(
    _accountIds: ReadonlyArray<string> | string,
    _accessToken: string,
  ): Promise<ReadonlyArray<Transaction>> {
    const someFields = {
      date: new Date().toDateString(),
      description: "Test transaction",
      cleanedDescription: "Test transaction",
      remoteAccountName: "Test account",
    }
    return [
      {
        id: "1",
        amount: 100,
        ...someFields,
      },
      {
        id: "2",
        amount: 200,
        ...someFields,
      },
      {
        id: "3",
        amount: -50,
        ...someFields,
      },
    ]
  }
}
